MAW: Minimal Absent Words
===

<b>Description</b>: MAW is a software suite on the computation and application of Minimal Absent Words. MAW includes among others the fastest (to the best of our knowledge) implementation for computing MAWs in intenal memory, an OpenMP implementation for computing MAWs, and an implementation for computing MAWs in external memory.

To compile <b>MAW</b> (Internal Memory), please follow the instructions given in file INSTALL.

When publishing work that is based on the results from MAW please cite:
```
C. Barton, A. Heliou, L. Mouchard, S. P. Pissis:
Linear-time Computation of Minimal Absent Words Using Suffix Array. 
BMC Bioinformatics 15: 388 (2014)
```
To compile <b>emMAW</b> (External Memory), please change to directory <b>em-maw</b> and follow the instructions given in file INSTALL.

When publishing work that is based on the results from emMAW please cite:
```
A. Heliou, S. P. Pissis, S. J. Puglisi: 
emMAW: Computing Minimal Absent Words in External Memory.
Bioinformatics 33(17): 2746-2749 (2017)
```
To compile <b>pMAW</b> (OpenMP), please change to directory <b>pmaw</b> and follow the instructions given in file INSTALL.

When publishing work that is based on the results from pMAW please cite:
```
C. Barton, A. Heliou, L. Mouchard, S. P. Pissis: 
Parallelising the Computation of Minimal Absent Words. 
PPAM (2) 2015: 243-253
```
To compile <b>scMAW</b> (Sequence Comparison), please change to directory <b>sc-maw</b> and follow the instructions given in file INSTALL.

When publishing work that is based on the results from scMAW please cite:
```
M. Crochemore, G. Fici, R. Mercas, S. P. Pissis:
Linear-Time Sequence Comparison Using Minimal Absent Words & Applications. 
LATIN 2016: 334-346
```
<b>License</b>: GNU GPLv3 License; Copyright (C) 2014 Alice Heliou and Solon P. Pissis.
